/**
 */
package de.mdelab.mlcallactions.impl;

import de.mdelab.mlcallactions.CallActionParameter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EParameter;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.ocl.pivot.evaluation.Executor;
import org.eclipse.ocl.pivot.ids.IdResolver;
import org.eclipse.ocl.pivot.ids.TypeId;
import org.eclipse.ocl.pivot.library.oclany.OclAnyToStringOperation;
import org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation;
import org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation;
import org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation;
import org.eclipse.ocl.pivot.library.string.StringConcatOperation;
import org.eclipse.ocl.pivot.messages.PivotMessages;
import org.eclipse.ocl.pivot.utilities.PivotUtil;
import org.eclipse.ocl.pivot.utilities.ValueUtil;
import org.eclipse.ocl.pivot.values.IntegerValue;
import org.eclipse.ocl.pivot.values.InvalidValueException;
import org.eclipse.ocl.pivot.values.OrderedSetValue;
import org.eclipse.ocl.pivot.values.TupleValue;
import de.mdelab.mlcallactions.EOperationCallAction;
import de.mdelab.mlcallactions.MlcallactionsPackage;
import de.mdelab.mlcallactions.MlcallactionsTables;
import de.mdelab.mlexpressions.MLExpression;
import java.lang.reflect.InvocationTargetException;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>EOperation Call Action</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlcallactions.impl.EOperationCallActionImpl#getThisParameterValue <em>This Parameter Value</em>}</li>
 *   <li>{@link de.mdelab.mlcallactions.impl.EOperationCallActionImpl#getEOperation <em>EOperation</em>}</li>
 * </ul>
 *
 * @generated
 */
public class EOperationCallActionImpl extends ParameterizedCallActionImpl implements EOperationCallAction {
	/**
	 * The cached value of the '{@link #getThisParameterValue()
	 * <em>This Parameter Value</em>}' containment reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getThisParameterValue()
	 * @generated
	 * @ordered
	 */
	protected MLExpression thisParameterValue;

	/**
	 * The cached value of the '{@link #getEOperation() <em>EOperation</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getEOperation()
	 * @generated
	 * @ordered
	 */
	protected EOperation eOperation;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected EOperationCallActionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlcallactionsPackage.Literals.EOPERATION_CALL_ACTION;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public MLExpression getThisParameterValue() {
		return thisParameterValue;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetThisParameterValue(MLExpression newThisParameterValue, NotificationChain msgs) {
		MLExpression oldThisParameterValue = thisParameterValue;
		thisParameterValue = newThisParameterValue;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
					MlcallactionsPackage.EOPERATION_CALL_ACTION__THIS_PARAMETER_VALUE, oldThisParameterValue,
					newThisParameterValue);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setThisParameterValue(MLExpression newThisParameterValue) {
		if (newThisParameterValue != thisParameterValue) {
			NotificationChain msgs = null;
			if (thisParameterValue != null)
				msgs = ((InternalEObject) thisParameterValue).eInverseRemove(this,
						EOPPOSITE_FEATURE_BASE - MlcallactionsPackage.EOPERATION_CALL_ACTION__THIS_PARAMETER_VALUE,
						null, msgs);
			if (newThisParameterValue != null)
				msgs = ((InternalEObject) newThisParameterValue).eInverseAdd(this,
						EOPPOSITE_FEATURE_BASE - MlcallactionsPackage.EOPERATION_CALL_ACTION__THIS_PARAMETER_VALUE,
						null, msgs);
			msgs = basicSetThisParameterValue(newThisParameterValue, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlcallactionsPackage.EOPERATION_CALL_ACTION__THIS_PARAMETER_VALUE, newThisParameterValue,
					newThisParameterValue));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EOperation getEOperation() {
		if (eOperation != null && eOperation.eIsProxy()) {
			InternalEObject oldEOperation = (InternalEObject) eOperation;
			eOperation = (EOperation) eResolveProxy(oldEOperation);
			if (eOperation != oldEOperation) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE,
							MlcallactionsPackage.EOPERATION_CALL_ACTION__EOPERATION, oldEOperation, eOperation));
			}
		}
		return eOperation;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation basicGetEOperation() {
		return eOperation;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setEOperation(EOperation newEOperation) {
		EOperation oldEOperation = eOperation;
		eOperation = newEOperation;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlcallactionsPackage.EOPERATION_CALL_ACTION__EOPERATION, oldEOperation, eOperation));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean parametersMatchOperation(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "EOperationCallAction::parametersMatchOperation";
		try {
			/**
			 *
			 * inv parametersMatchOperation:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = self.eOperation.eParameters->forAll(par |
			 *             self.parameters->exists(par2 | par2.name = par.name) and
			 *             self.parameters->any(par2 | par2.name = par.name).type = par.eType)
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{
			 *               message = 'The provided parameters do not match the signature of eOperation \''.concat(
			 *                 self.eOperation.toString())
			 *               .concat('\'.'), status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
			final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
					MlcallactionsPackage.Literals.EOPERATION_CALL_ACTION___PARAMETERS_MATCH_OPERATION__DIAGNOSTICCHAIN_MAP);
			final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, severity_0, MlcallactionsTables.INT_0).booleanValue();
			/*@NonInvalid*/ boolean symbol_2;
			if (le) {
				symbol_2 = true;
			} else {
				/*@Caught*/ Object CAUGHT_symbol_1;
				try {
					final /*@NonInvalid*/ EOperation eOperation = this.getEOperation();
					final /*@NonInvalid*/ List<EParameter> eParameters = eOperation.getEParameters();
					final /*@NonInvalid*/ OrderedSetValue BOXED_eParameters = idResolver
							.createOrderedSetOfAll(MlcallactionsTables.ORD_CLSSid_EParameter, eParameters);
					/*@Thrown*/ Object accumulator = ValueUtil.TRUE_VALUE;
					Iterator<Object> ITERATOR_par = BOXED_eParameters.iterator();
					/*@Thrown*/ Boolean status;
					while (true) {
						if (!ITERATOR_par.hasNext()) {
							if (accumulator == null) {
								status = null;
							} else if (accumulator == ValueUtil.TRUE_VALUE) {
								status = ValueUtil.TRUE_VALUE;
							} else {
								throw (InvalidValueException) accumulator;
							}
							break;
						}
						/*@NonInvalid*/ EParameter par = (EParameter) ITERATOR_par.next();
						/**
						 *
						 * self.parameters->exists(par2 | par2.name = par.name) and
						 * self.parameters->any(par2 | par2.name = par.name).type = par.eType
						 */
						/*@Caught*/ Object CAUGHT_and;
						try {
							final /*@NonInvalid*/ List<CallActionParameter> parameters = this.getParameters();
							final /*@NonInvalid*/ OrderedSetValue BOXED_parameters = idResolver.createOrderedSetOfAll(
									MlcallactionsTables.ORD_CLSSid_CallActionParameter, parameters);
							/*@Thrown*/ Object accumulator_0 = ValueUtil.FALSE_VALUE;
							Iterator<Object> ITERATOR_par2 = BOXED_parameters.iterator();
							/*@NonInvalid*/ Boolean exists;
							while (true) {
								if (!ITERATOR_par2.hasNext()) {
									if (accumulator_0 == ValueUtil.FALSE_VALUE) {
										exists = ValueUtil.FALSE_VALUE;
									} else {
										throw (InvalidValueException) accumulator_0;
									}
									break;
								}
								/*@NonInvalid*/ CallActionParameter par2 = (CallActionParameter) ITERATOR_par2.next();
								/**
								 * par2.name = par.name
								 */
								final /*@NonInvalid*/ String name = par2.getName();
								final /*@NonInvalid*/ String name_0 = par.getName();
								final /*@NonInvalid*/ boolean eq = (name != null) ? name.equals(name_0)
										: (name_0 == null);
								//
								if (eq) { // Normal successful body evaluation result
									exists = ValueUtil.TRUE_VALUE;
									break; // Stop immediately
								} else if (!eq) { // Normal unsuccessful body evaluation result
									; // Carry on
								} else { // Impossible badly typed result
									accumulator_0 = new InvalidValueException(PivotMessages.NonBooleanBody, "exists");
								}
							}
							final /*@Thrown*/ Boolean and;
							if (exists == ValueUtil.FALSE_VALUE) {
								and = ValueUtil.FALSE_VALUE;
							} else {
								/*@Caught*/ Object CAUGHT_eq_1;
								try {
									Iterator<Object> ITERATOR_par2_0 = BOXED_parameters.iterator();
									/*@Thrown*/ CallActionParameter any;
									while (true) {
										if (!ITERATOR_par2_0.hasNext()) {
											throw new InvalidValueException("Nothing to return for ''any''");
										}
										/*@NonInvalid*/ CallActionParameter par2_0 = (CallActionParameter) ITERATOR_par2_0
												.next();
										/**
										 * par2.name = par.name
										 */
										final /*@NonInvalid*/ String name_1 = par2_0.getName();
										final /*@NonInvalid*/ String name_2 = par.getName();
										final /*@NonInvalid*/ boolean eq_0 = (name_1 != null) ? name_1.equals(name_2)
												: (name_2 == null);
										//
										if (eq_0) { // Carry on till something found
											any = par2_0;
											break;
										}
									}
									final /*@Thrown*/ EClassifier type = any.getType();
									final /*@NonInvalid*/ EClassifier eType = par.getEType();
									final /*@Thrown*/ boolean eq_1 = (type != null) ? type.equals(eType)
											: (eType == null);
									CAUGHT_eq_1 = eq_1;
								} catch (Exception e) {
									CAUGHT_eq_1 = ValueUtil.createInvalidValue(e);
								}
								if (CAUGHT_eq_1 == ValueUtil.FALSE_VALUE) {
									and = ValueUtil.FALSE_VALUE;
								} else {
									if (CAUGHT_eq_1 instanceof InvalidValueException) {
										throw (InvalidValueException) CAUGHT_eq_1;
									}
									if (exists == null) {
										and = null;
									} else {
										and = ValueUtil.TRUE_VALUE;
									}
								}
							}
							CAUGHT_and = and;
						} catch (Exception e) {
							CAUGHT_and = ValueUtil.createInvalidValue(e);
						}
						//
						if (CAUGHT_and == ValueUtil.FALSE_VALUE) { // Normal unsuccessful body evaluation result
							status = ValueUtil.FALSE_VALUE;
							break; // Stop immediately
						} else if (CAUGHT_and == ValueUtil.TRUE_VALUE) { // Normal successful body evaluation result
							; // Carry on
						} else if (CAUGHT_and == null) { // Abnormal null body evaluation result
							if (accumulator == ValueUtil.TRUE_VALUE) {
								accumulator = null; // Cache a null failure
							}
						} else if (CAUGHT_and instanceof InvalidValueException) { // Abnormal exception evaluation result
							accumulator = CAUGHT_and; // Cache an exception failure
						} else { // Impossible badly typed result
							accumulator = new InvalidValueException(PivotMessages.NonBooleanBody, "forAll");
						}
					}
					final /*@Thrown*/ boolean eq_2 = status == Boolean.TRUE;
					/*@Thrown*/ Object symbol_1;
					if (eq_2) {
						symbol_1 = ValueUtil.TRUE_VALUE;
					} else {
						final /*@NonInvalid*/ String toString = OclAnyToStringOperation.INSTANCE.evaluate(eOperation);
						final /*@NonInvalid*/ String concat = StringConcatOperation.INSTANCE.evaluate(
								MlcallactionsTables.STR_The_32_provided_32_parameters_32_do_32_not_32_match_32_the_32_signature_32_of_32_eOperation,
								toString);
						final /*@NonInvalid*/ String concat_0 = StringConcatOperation.INSTANCE.evaluate(concat,
								MlcallactionsTables.STR__39_);
						final /*@Thrown*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlcallactionsTables.TUPLid_,
								concat_0, status);
						symbol_1 = symbol_0;
					}
					CAUGHT_symbol_1 = symbol_1;
				} catch (Exception e) {
					CAUGHT_symbol_1 = ValueUtil.createInvalidValue(e);
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, severity_0, CAUGHT_symbol_1, MlcallactionsTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
		case MlcallactionsPackage.EOPERATION_CALL_ACTION__THIS_PARAMETER_VALUE:
			return basicSetThisParameterValue(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case MlcallactionsPackage.EOPERATION_CALL_ACTION__THIS_PARAMETER_VALUE:
			return getThisParameterValue();
		case MlcallactionsPackage.EOPERATION_CALL_ACTION__EOPERATION:
			if (resolve)
				return getEOperation();
			return basicGetEOperation();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case MlcallactionsPackage.EOPERATION_CALL_ACTION__THIS_PARAMETER_VALUE:
			setThisParameterValue((MLExpression) newValue);
			return;
		case MlcallactionsPackage.EOPERATION_CALL_ACTION__EOPERATION:
			setEOperation((EOperation) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case MlcallactionsPackage.EOPERATION_CALL_ACTION__THIS_PARAMETER_VALUE:
			setThisParameterValue((MLExpression) null);
			return;
		case MlcallactionsPackage.EOPERATION_CALL_ACTION__EOPERATION:
			setEOperation((EOperation) null);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case MlcallactionsPackage.EOPERATION_CALL_ACTION__THIS_PARAMETER_VALUE:
			return thisParameterValue != null;
		case MlcallactionsPackage.EOPERATION_CALL_ACTION__EOPERATION:
			return eOperation != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	@SuppressWarnings("unchecked")
	public Object eInvoke(int operationID, EList<?> arguments) throws InvocationTargetException {
		switch (operationID) {
		case MlcallactionsPackage.EOPERATION_CALL_ACTION___PARAMETERS_MATCH_OPERATION__DIAGNOSTICCHAIN_MAP:
			return parametersMatchOperation((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		}
		return super.eInvoke(operationID, arguments);
	}

} // EOperationCallActionImpl
